Option Explicit On
Imports System.Runtime.InteropServices
Module AL2UsbC
    '**********************************************************************************************
    '
    '@MPL-45-02v2.00 definitions, types, functions for Visual Basic.NET      5.4502.15.1508
    '
    '**********************************************************************************************

    '*** DEFINITION ***
    Public Const MC07_AL2USB_USB_0 As Short = &H5000
    Public Const MC07_AL2USB_USB_1 As Short = &H5001
    Public Const MC07_AL2USB_USB_2 As Short = &H5002
    Public Const MC07_AL2USB_USB_3 As Short = &H5003

    Public Const MC07_COMM_RATE_2 As Short = 0
    Public Const MC07_COMM_RATE_5 As Short = 1
    Public Const MC07_COMM_RATE_10 As Short = 2
    Public Const MC07_COMM_RATE_20 As Short = 3

    Public Const MC07_SLAVE_1 As Short = &H10
    Public Const MC07_SLAVE_2 As Short = &H20
    Public Const MC07_SLAVE_3 As Short = &H30
    Public Const MC07_SLAVE_4 As Short = &H40
    Public Const MC07_SLAVE_5 As Short = &H50
    Public Const MC07_SLAVE_6 As Short = &H60
    Public Const MC07_SLAVE_7 As Short = &H70
    Public Const MC07_SLAVE_8 As Short = &H80
    Public Const MC07_SLAVE_9 As Short = &H90
    Public Const MC07_SLAVE_A As Short = &HA0
    Public Const MC07_SLAVE_B As Short = &HB0
    Public Const MC07_SLAVE_C As Short = &HC0
    Public Const MC07_SLAVE_D As Short = &HD0
    Public Const MC07_SLAVE_E As Short = &HE0
    Public Const MC07_SLAVE_F As Short = &HF0

    Public Const MC07_SUB_UNIT_0 As Short = &H800
    Public Const MC07_SUB_UNIT_1 As Short = &H900
    Public Const MC07_SUB_UNIT_2 As Short = &HA00
    Public Const MC07_SUB_UNIT_3 As Short = &HB00

    Public Const MC07_X As Short = 0
    Public Const MC07_Y As Short = 1
    Public Const MC07_Z As Short = 2
    Public Const MC07_A As Short = 3

    Public Const MC07_EX_UNIT_COMM_RATE_5 As Short = 2

    Public Const MC07_EX_UNIT_COMM_16BIT As Short = 0
    Public Const MC07_EX_UNIT_COMM_32BIT As Short = 1

    Public Const MC07_EX_UNIT_COMM_START As Short = 0
    Public Const MC07_EX_UNIT_COMM_STOP As Short = 1
    Public Const MC07_EX_UNIT_COMM_DISC_LATCH_CLR As Short = 2

    Public Const MC07_GEX_UNIT_COMM_RATE_10 As Short = 3

    Public Const MC07_GEX_UNIT_COMM_64BIT As Short = 2

    Public Const MC07_GEX_UNIT_COMM_START As Short = 0
    Public Const MC07_GEX_UNIT_COMM_STOP As Short = 1
    Public Const MC07_GEX_UNIT_COMM_DISC_LATCH_CLR As Short = 2

    Public Const MC07_STATUS1 As Short = 0
    Public Const MC07_STATUS2 As Short = 1
    Public Const MC07_STATUS3 As Short = 2
    Public Const MC07_STATUS4 As Short = 3
    Public Const MC07_STATUS5 As Short = 4
    Public Const MC07_ORG_STATUS As Short = 5

    Public Const MC07_GP_IN As Short = &H0
    Public Const MC07_GP_OUT As Short = &H1
    Public Const MC07_EXP0_IN As Short = &H2
    Public Const MC07_EXP1_IN As Short = &H3
    Public Const MC07_EXP0_OUT As Short = &H4
    Public Const MC07_EXP1_OUT As Short = &H5
    Public Const MC07_CTLP0_IN As Short = &H6
    Public Const MC07_CTLP0_OUT As Short = &H7
    Public Const MC07_GP0_IN As Short = &H8
    Public Const MC07_GP1_IN As Short = &H9
    Public Const MC07_GP0_OUT As Short = &HA
    Public Const MC07_GP1_OUT As Short = &HB
    Public Const MC07_GEXP0_IN As Short = &H20
    Public Const MC07_GEXP1_IN As Short = &H21
    Public Const MC07_GEXP2_IN As Short = &H22
    Public Const MC07_GEXP3_IN As Short = &H23
    Public Const MC07_GEXP0_OUT As Short = &H28
    Public Const MC07_GEXP1_OUT As Short = &H29
    Public Const MC07_GEXP2_OUT As Short = &H2A
    Public Const MC07_GEXP3_OUT As Short = &H2B

    Public Const MC07_ORG0 As Short = 0
    Public Const MC07_ORG1 As Short = 1
    Public Const MC07_ORG2 As Short = 2
    Public Const MC07_ORG3 As Short = 3
    Public Const MC07_ORG4 As Short = 4
    Public Const MC07_ORG5 As Short = 5
    Public Const MC07_ORG10 As Short = 10
    Public Const MC07_ORG11 As Short = 11
    Public Const MC07_ORG12 As Short = 12

    Public Const MC07_CCW As Short = 0
    Public Const MC07_CW As Short = 1

    Public Const MC07_SEL_X As Integer = &H1
    Public Const MC07_SEL_Y As Integer = &H2
    Public Const MC07_SEL_Z As Integer = &H4
    Public Const MC07_SEL_A As Integer = &H8
    Public Const MC07_SEL_X_Y As Integer = &H3
    Public Const MC07_SEL_X_Z As Integer = &H5
    Public Const MC07_SEL_X_A As Integer = &H9
    Public Const MC07_SEL_Y_Z As Integer = &H6
    Public Const MC07_SEL_Y_A As Integer = &HA
    Public Const MC07_SEL_Z_A As Integer = &HC
    Public Const MC07_SEL_X_Y_Z As Integer = &H7
    Public Const MC07_SEL_X_Y_A As Integer = &HB
    Public Const MC07_SEL_X_Z_A As Integer = &HD
    Public Const MC07_SEL_Y_Z_A As Integer = &HE
    Public Const MC07_SEL_X_Y_Z_A As Integer = &HF

    Public Const MC07_SEL_GP_OUT As Integer = &H1
    Public Const MC07_SEL_EXP0_OUT As Integer = &H4
    Public Const MC07_SEL_EXP1_OUT As Integer = &H8
    Public Const MC07_SEL_CTLP0_OUT As Integer = &H2
    Public Const MC07_SEL_GP0_OUT As Integer = &H10
    Public Const MC07_SEL_GP1_OUT As Integer = &H20
    Public Const MC07_SEL_EXP0_EXP1_OUT As Integer = &HC
    Public Const MC07_SEL_GP0_GP1_OUT As Integer = &H30

    Public Const MC07_SEL_GEXP0_OUT As Integer = &H1
    Public Const MC07_SEL_GEXP1_OUT As Integer = &H2
    Public Const MC07_SEL_GEXP2_OUT As Integer = &H4
    Public Const MC07_SEL_GEXP3_OUT As Integer = &H8
    Public Const MC07_SEL_GEXP0_GEXP1_OUT As Integer = &H3
    Public Const MC07_SEL_GEXP2_GEXP3_OUT As Integer = &HC

    Public Const MC07_SEL_GEXU0_OUT As Integer = &H100
    Public Const MC07_SEL_GEXU1_OUT As Integer = &H200
    Public Const MC07_SEL_GEXU2_OUT As Integer = &H400
    Public Const MC07_SEL_GEXU3_OUT As Integer = &H800

    Public Const MC07_SEL_GP_IN As Integer = &H10000
    Public Const MC07_SEL_EXP0_IN As Integer = &H40000
    Public Const MC07_SEL_EXP1_IN As Integer = &H80000
    Public Const MC07_SEL_CTLP0_IN As Integer = &H20000
    Public Const MC07_SEL_GP0_IN As Integer = &H100000
    Public Const MC07_SEL_GP1_IN As Integer = &H200000
    Public Const MC07_SEL_EXP0_EXP1_IN As Integer = &HC0000
    Public Const MC07_SEL_GP0_GP1_IN As Integer = &H300000

    Public Const MC07_SEL_GEXP0_IN As Integer = &H10000
    Public Const MC07_SEL_GEXP1_IN As Integer = &H20000
    Public Const MC07_SEL_GEXP2_IN As Integer = &H40000
    Public Const MC07_SEL_GEXP3_IN As Integer = &H80000
    Public Const MC07_SEL_GEXP0_GEXP1_IN As Integer = &H30000
    Public Const MC07_SEL_GEXP2_GEXP3_IN As Integer = &HC0000

    Public Const MC07_SEL_GEXU0_IN As Integer = &H1000000
    Public Const MC07_SEL_GEXU1_IN As Integer = &H2000000
    Public Const MC07_SEL_GEXU2_IN As Integer = &H4000000
    Public Const MC07_SEL_GEXU3_IN As Integer = &H8000000

    '*** RESULT STRUCTURE ***
    Structure MC07_S_RESULT
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public MC07_Result() As Short
        Public Sub Initialize()
            ReDim MC07_Result(3)
        End Sub
    End Structure

    '*** DATA STRUCTURE ***
    Structure MC07_S_DATA
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public MC07_Data() As Short
        Public Sub Initialize()
            ReDim MC07_Data(3)
        End Sub
    End Structure

    '*** COMMAND DATA STRUCTURE ***
    Structure MC07_S_COMMAND_DATA
        Public Command As Short
        Public Data As Integer
    End Structure

    '*** STATUS DATA STRUCTURE ***
    Structure MC07_S_STATUS_DATA
        Public Status1 As Short
        Public Data As Integer
    End Structure

    '*** SLAVE INFO STRUCTURE ***
    Structure MC07_S_SLAVE_INFO
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=15)> Public SlaveType() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=60)> Public GExuType() As Short
        Public Sub Initialize()
            ReDim SlaveType(14)
            ReDim GExuType(59)
        End Sub
    End Structure

    '*** IN PORT STRUCTURE ***
    Structure MC07_S_IN_PORT
        Public Gpin As Short
        Public Gp0in As Short
        Public Gp1in As Short
        Public Exp0in As Short
        Public Exp1in As Short
        Public Ctlp0in As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu0in() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu1in() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu2in() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu3in() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu0out() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu1out() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu2out() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu3out() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExpin() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExpout() As Short
        Public Sub Initialize()
            ReDim GExu0in(3)
            ReDim GExu1in(3)
            ReDim GExu2in(3)
            ReDim GExu3in(3)
            ReDim GExu0out(3)
            ReDim GExu1out(3)
            ReDim GExu2out(3)
            ReDim GExu3out(3)
            ReDim GExpin(3)
            ReDim GExpout(3)
        End Sub
    End Structure

    '*** OUT PORT STRUCTURE ***
    Structure MC07_S_OUT_PORT
        Public Gpout As Short
        Public Gp0out As Short
        Public Gp1out As Short
        Public Exp0out As Short
        Public Exp1out As Short
        Public Ctlp0out As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu0out() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu1out() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu2out() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExu3out() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public GExpout() As Short
        Public Sub Initialize()
            ReDim GExu0out(3)
            ReDim GExu1out(3)
            ReDim GExu2out(3)
            ReDim GExu3out(3)
            ReDim GExpout(3)
        End Sub
    End Structure

    '*** UNIT STATUS STRUCTURE ***
    Structure MC07_S_UNIT_STATUS
        Public X As MC07_S_STATUS_DATA
        Public Y As MC07_S_STATUS_DATA
        Public Z As MC07_S_STATUS_DATA
        Public A As MC07_S_STATUS_DATA
        Public InPort As MC07_S_IN_PORT
        Public Sub Initialize()
            InPort.Initialize()
        End Sub
    End Structure

    '*** UNIT COMMAND STRUCTURE ***
    Structure MC07_S_UNIT_COMMAND
        Public X As MC07_S_COMMAND_DATA
        Public Y As MC07_S_COMMAND_DATA
        Public Z As MC07_S_COMMAND_DATA
        Public A As MC07_S_COMMAND_DATA
        Public OutPort As MC07_S_OUT_PORT
        Public Sub Initialize()
            OutPort.Initialize()
        End Sub
    End Structure

    '*** AXIS MCM STRUCTURE ***
    Structure MC07_S_AXIS_MCM_STATUS
        Public Status As Short
        Public NopData As Short
        Public Data As Integer
    End Structure

    '*** UNIT MCM STRUCTURE ***
    Structure MC07_S_UNIT_MCM_STATUS
        Public McmStatus1 As Short
        Public McmStatus2 As Short
        Public X As MC07_S_AXIS_MCM_STATUS
        Public Y As MC07_S_AXIS_MCM_STATUS
        Public Z As MC07_S_AXIS_MCM_STATUS
        Public A As MC07_S_AXIS_MCM_STATUS
        Public Gpin As Short
        Public Ctlp0in As Short
        Public Exp0in As Short
        Public Exp1in As Short
    End Structure

    '*** AXIS MCM ERROR STRUCTURE ***
    Structure MC07_S_AXIS_MCM_ERROR_STATUS
        Public ErrorCode As Short
        Public MccErrorStatus As Short
        Public MccErrorStatusMask As Short
        Public OriginErrorStatus As Short
    End Structure

    '*** UNIT MCM AXIS STRUCTURE ***
    Structure MC07_S_UNIT_MCM_ERROR_STATUS
        Public X As MC07_S_AXIS_MCM_ERROR_STATUS
        Public Y As MC07_S_AXIS_MCM_ERROR_STATUS
        Public Z As MC07_S_AXIS_MCM_ERROR_STATUS
        Public A As MC07_S_AXIS_MCM_ERROR_STATUS
    End Structure

    '*** AXIS MCM SPEC STRUCTURE ***
    Structure MC07_S_AXIS_MCM_SPEC
        Public Spec As Short
    End Structure

    '*** UNIT MCM STRUCTURE ***
    Structure MC07_S_UNIT_MCM_SPEC
        Public X As MC07_S_AXIS_MCM_SPEC
        Public Y As MC07_S_AXIS_MCM_SPEC
        Public Z As MC07_S_AXIS_MCM_SPEC
        Public A As MC07_S_AXIS_MCM_SPEC
    End Structure

    '*** AXIS MCM INFO STRUCTURE ***
    Structure MC07_S_AXIS_MCM_INFO
        Public Address As Integer
    End Structure

    '*** UNIT MCM STRUCTURE ***
    Structure MC07_S_UNIT_MCM_INFO
        Public SheetNo As Short
        Public X As MC07_S_AXIS_MCM_INFO
        Public Y As MC07_S_AXIS_MCM_INFO
        Public Z As MC07_S_AXIS_MCM_INFO
        Public A As MC07_S_AXIS_MCM_INFO
    End Structure

    '*** AXIS MCM START STRUCTURE ***
    Structure MC07_S_AXIS_MCM_START_DATA
        Public Address As Integer
    End Structure

    '*** UNIT MCM START STRUCTURE ***
    Structure MC07_S_UNIT_MCM_START_DATA
        Public X As MC07_S_AXIS_MCM_START_DATA
        Public Y As MC07_S_AXIS_MCM_START_DATA
        Public Z As MC07_S_AXIS_MCM_START_DATA
        Public A As MC07_S_AXIS_MCM_START_DATA
    End Structure

    '*** COMMAND BUFFER STRUCTURE ***
    Structure MC07_S_COMMAND_BUF
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> Public Command() As Short
        Public Sub Initialize()
            ReDim Command(15)
        End Sub
    End Structure

    '*** DATA BUFFER STRUCTURE ***
    Structure MC07_S_DATA_BUF
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> Public Data() As Integer
        Public Sub Initialize()
            ReDim Data(15)
        End Sub
    End Structure

    '*** STATUS BUFFER STRUCTURE ***
    Structure MC07_S_STATUS_BUF
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> Public Status() As Short
        Public Sub Initialize()
            ReDim Status(15)
        End Sub
    End Structure

    '*** SPEEDARATE SETUP STRUCTURE ***
    Structure MC07_S_SPEED_RATE
        Public FSpd As Integer
        Public HighSpeed As Integer
        Public LowSpeed As Integer
        Public EndLowSpeed As Integer
        Public SUArea As Integer
        Public SDArea As Integer
        Public SUH As Integer
        Public SDH As Integer
        Public URateNo As Integer
        Public DRateNo As Integer
    End Structure

    '*** X/Y POSITION STRUCTURE ***
    Structure MC07_S_XY_POSITION
        Public X As Integer
        Public Y As Integer
    End Structure

    '*** MPL ORIGIN DRIVE PARAMETER STRUCTURE ***
    Structure MC07_S_ORG_PARAM
        Public Spec As Integer
        Public MarginPulse As Integer
        Public LimitDelay As Integer
        Public ScanDelay As Integer
        Public PulseDelay As Integer
        Public CScanErrorPulse As Integer
        Public PulseErrorPulse As Integer
        Public OffsetPulse As Integer
        Public PresetPulse As Integer
    End Structure


    '*** MPL Function Declarations ***
    Declare Function MC07_Environment Lib "AL2UsbC.dll" (ByVal BoardNo As Short, ByVal CommRate As Short, ByVal RetryCount As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadSlaveInfo Lib "AL2UsbC.dll" (ByVal BoardNo As Short, ByRef psSlaveInfo As MC07_S_SLAVE_INFO, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ErrCount Lib "AL2UsbC.dll" (ByVal BoardNo As Short, ByRef pCount As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ClrErrCount Lib "AL2UsbC.dll" (ByVal BoardNo As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UOpen Lib "AL2UsbC.dll" (ByVal UnitNo As Short, ByRef phUnit As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UClose Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UClrError Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWExUnitCommMode Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal CommRate As Short, ByVal RetryCount As Short, ByVal IoBit As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWExUnitCommControl Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal ControlSel As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URExUnitCommStatus Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URExUnitCommMode Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByRef pCommRate As Short, ByRef pRetryCount As Short, ByRef pIoBit As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWGExUnitCommMode Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal CommRate As Short, ByVal RetryCount As Short, ByVal IoBit As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWGExUnitCommControl Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal ControlSel As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URGExUnitCommStatus Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URGExUnitCommMode Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByRef pCommRate As Short, ByRef pRetryCount As Short, ByRef pIoBit As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWDriveIo Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByVal IoPortSel As Integer, ByRef psUnitCmd As MC07_S_UNIT_COMMAND, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWRDrive Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitCmd As MC07_S_UNIT_COMMAND, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URStatus1Io Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByVal IoPortSel As Integer, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URStatus1PcntIo Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByVal IoPortSel As Integer, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPortOut Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal IoPortSel As Integer, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPortOrOut Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal IoPortSel As Integer, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPortAndOut Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal IoPortSel As Integer, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPortIn Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal IoPortSel As Integer, ByRef psInPort As MC07_S_IN_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UReadMcmStatus Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmStatus As MC07_S_UNIT_MCM_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UReadMcmErrorStatus Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmErrorStatus As MC07_S_UNIT_MCM_ERROR_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_USetMcmSpec0 Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal Spec As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UGetMcmSpec0 Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByRef pSpec As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_USetMcmSpec1 Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmSpec As MC07_S_UNIT_MCM_SPEC, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UGetMcmSpec1 Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmSpec As MC07_S_UNIT_MCM_SPEC, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_USetMcmSpec2 Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmSpec As MC07_S_UNIT_MCM_SPEC, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UGetMcmSpec2 Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmSpec As MC07_S_UNIT_MCM_SPEC, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_USetMcmSpec3 Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmSpec As MC07_S_UNIT_MCM_SPEC, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UGetMcmSpec3 Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmSpec As MC07_S_UNIT_MCM_SPEC, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UReleaseMcmSheetLock Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal SheetNo As Short, ByVal Password() As Byte, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UDownloadMcmSheet Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal SheetNo As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWriteMcmRam Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal Axis As Short, ByVal Address As Integer, ByRef psCmdData As MC07_S_COMMAND_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UReadMcmRam Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal Axis As Short, ByVal Address As Integer, ByRef psCmdData As MC07_S_COMMAND_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UReadMcmInfo Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmInfo As MC07_S_UNIT_MCM_INFO, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWaitMcmReady Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByVal WaitTime As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UReadMcmWaitStatus Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef pWaitSts As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UBreakMcmWait Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UStartMcm Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitMcmStartData As MC07_S_UNIT_MCM_START_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPauseMcm Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URestartMcm Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UFsstopMcm Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_USlstopMcm Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UClrMcmError Lib "AL2UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BOpen Lib "AL2UsbC.dll" (ByVal UnitNo As Short, ByVal Axis As Short, ByRef phDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BClose Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ClrError Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BufWDrive Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psCmdBuf As MC07_S_COMMAND_BUF, ByRef psDataBuf As MC07_S_DATA_BUF, ByVal Count As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWDrive Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWData Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IWDrive Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IWData Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWDriveBuf Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal CmdDataBuf() As MC07_S_COMMAND_DATA, ByVal Count As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveCommand Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pCmd As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveData1 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveData2 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_AllRStatus Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psStsBuf As MC07_S_STATUS_BUF, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus1 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus2 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus3 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus4 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus5 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatusBuf Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal StatusBuf() As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LRDrive Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IRDrive Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRDriveData1 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRDriveData2 Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWRDrive Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef pWriteData As Integer, ByRef pReadData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWRDrive Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef pReadData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRNopData Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWaitDriveCommand Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal WaitTime As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWaitComregNotFull Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal WaitTime As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BIsWait Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pWaitSts As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BBreakWait Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetSpeedRate Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal ResolNo As Short, ByRef psSpeedRate As MC07_S_SPEED_RATE, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadSpeedRate Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pResolNo As Short, ByRef psSpeedRate As MC07_S_SPEED_RATE, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_McIncStrCp Lib "AL2UsbC.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByVal DrvSpec As Short, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_McIncCirCp Lib "AL2UsbC.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByVal DrvSpec As Short, ByVal Dir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IncStrCp Lib "AL2UsbC.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByVal DrvSpec As Short, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IncCirCp Lib "AL2UsbC.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByVal DrvSpec As Short, ByVal Dir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_GetCirShortPulse Lib "AL2UsbC.dll" (ByVal Dir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef pShortPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_GetCirCenterPosition Lib "AL2UsbC.dll" (ByRef psPassPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef pDir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IncFromAbs Lib "AL2UsbC.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByRef psAbsPosition As MC07_S_XY_POSITION, ByRef psIncPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadOrgStatus Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgSpec Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal Spec As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgMarginPulse Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal MarginPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgDelay Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal LimitDelay As Short, ByVal ScanDelay As Short, ByVal PulseDelay As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgErrorPulse Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal CScanErrorPulse As Integer, ByVal PulseErrorPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgOffsetPulse Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal OffsetPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgPresetPulse Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal PresetPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadOrgParam Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psOrgParam As MC07_S_ORG_PARAM, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ResetOrgFlag Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_Org Lib "AL2UsbC.dll" (ByVal hDev As Integer, ByVal OrgType As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Sub MC07_SetData Lib "AL2UsbC.dll" (ByVal Data As Integer, ByRef psData As MC07_S_DATA)
    Declare Function MC07_GetData Lib "AL2UsbC.dll" (ByRef psData As MC07_S_DATA) As Integer
    Declare Function MC07_BPortOpen Lib "AL2UsbC.dll" (ByVal UnitNo As Short, ByVal IoPort As Short, ByRef phPort As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortClose Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortOut Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortOrOut Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortAndOut Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortIn Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BSigActiveOut Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByVal SigNo As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BSigNotActiveOut Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByVal SigNo As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BSigIn Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByVal SigNo As Short, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWLatchEdge Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRLatchEdge Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWLatchClr Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRLatchData Lib "AL2UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean

End Module
