/******************************************************************************

	MPL-45-02v2.00 definitions, types, functions for Visual C++		5.4502.11.1508

******************************************************************************/
/******************************************************************************

	DEFINITION

******************************************************************************/

#define MC07_AL2USB_USB_0					0x5000
#define MC07_AL2USB_USB_1					0x5001
#define MC07_AL2USB_USB_2					0x5002
#define MC07_AL2USB_USB_3					0x5003

#define MC07_COMM_RATE_2					0
#define MC07_COMM_RATE_5					1
#define MC07_COMM_RATE_10					2
#define MC07_COMM_RATE_20					3

#define MC07_SLAVE_1						0x0010
#define MC07_SLAVE_2						0x0020
#define MC07_SLAVE_3						0x0030
#define MC07_SLAVE_4						0x0040
#define MC07_SLAVE_5						0x0050
#define MC07_SLAVE_6						0x0060
#define MC07_SLAVE_7						0x0070
#define MC07_SLAVE_8						0x0080
#define MC07_SLAVE_9						0x0090
#define MC07_SLAVE_A						0x00A0
#define MC07_SLAVE_B						0x00B0
#define MC07_SLAVE_C						0x00C0
#define MC07_SLAVE_D						0x00D0
#define MC07_SLAVE_E						0x00E0
#define MC07_SLAVE_F						0x00F0

#define MC07_SUB_UNIT_0						0x0800
#define MC07_SUB_UNIT_1						0x0900
#define MC07_SUB_UNIT_2						0x0A00
#define MC07_SUB_UNIT_3						0x0B00

#define MC07_X								0
#define MC07_Y								1
#define MC07_Z								2
#define MC07_A								3

#define MC07_EX_UNIT_COMM_RATE_5			2

#define MC07_EX_UNIT_COMM_16BIT				0
#define MC07_EX_UNIT_COMM_32BIT				1

#define MC07_EX_UNIT_COMM_START				0
#define MC07_EX_UNIT_COMM_STOP				1
#define MC07_EX_UNIT_COMM_DISC_LATCH_CLR	2

#define MC07_GEX_UNIT_COMM_RATE_10			3

#define MC07_GEX_UNIT_COMM_64BIT			2

#define MC07_GEX_UNIT_COMM_START			0
#define MC07_GEX_UNIT_COMM_STOP				1
#define MC07_GEX_UNIT_COMM_DISC_LATCH_CLR	2

#define MC07_STATUS1						0
#define MC07_STATUS2						1
#define MC07_STATUS3						2
#define MC07_STATUS4						3
#define MC07_STATUS5						4
#define MC07_ORG_STATUS						5

#define MC07_GP_IN							0x0
#define MC07_GP_OUT							0x1
#define MC07_EXP0_IN						0x2
#define MC07_EXP1_IN						0x3
#define MC07_EXP0_OUT						0x4
#define MC07_EXP1_OUT						0x5
#define MC07_CTLP0_IN						0x6
#define MC07_CTLP0_OUT						0x7
#define MC07_GP0_IN							0x8
#define MC07_GP1_IN							0x9
#define MC07_GP0_OUT						0xa
#define MC07_GP1_OUT						0xb

#define MC07_GEXP0_IN						0x20
#define MC07_GEXP1_IN						0x21
#define MC07_GEXP2_IN						0x22
#define MC07_GEXP3_IN						0x23
#define MC07_GEXP0_OUT						0x28
#define MC07_GEXP1_OUT						0x29
#define MC07_GEXP2_OUT						0x2A
#define MC07_GEXP3_OUT						0x2B

#define MC07_ORG0							0
#define MC07_ORG1							1
#define MC07_ORG2							2
#define MC07_ORG3							3
#define MC07_ORG4							4
#define MC07_ORG5							5
#define MC07_ORG10							10
#define MC07_ORG11							11
#define MC07_ORG12							12

#define MC07_CCW							0
#define MC07_CW								1

#define MC07_SEL_X							0x00000001
#define MC07_SEL_Y							0x00000002
#define MC07_SEL_Z							0x00000004
#define MC07_SEL_A							0x00000008
#define MC07_SEL_X_Y						0x00000003
#define MC07_SEL_X_Z						0x00000005
#define MC07_SEL_X_A						0x00000009
#define MC07_SEL_Y_Z						0x00000006
#define MC07_SEL_Y_A						0x0000000a
#define MC07_SEL_Z_A						0x0000000c
#define MC07_SEL_X_Y_Z						0x00000007
#define MC07_SEL_X_Y_A						0x0000000b
#define MC07_SEL_X_Z_A						0x0000000d
#define MC07_SEL_Y_Z_A						0x0000000e
#define MC07_SEL_X_Y_Z_A					0x0000000f

#define MC07_SEL_GP_OUT						0x00000001
#define MC07_SEL_EXP0_OUT					0x00000004
#define MC07_SEL_EXP1_OUT					0x00000008
#define MC07_SEL_CTLP0_OUT					0x00000002
#define MC07_SEL_GP0_OUT					0x00000010
#define MC07_SEL_GP1_OUT					0x00000020
#define MC07_SEL_EXP0_EXP1_OUT				0x0000000c
#define MC07_SEL_GP0_GP1_OUT				0x00000030

#define MC07_SEL_GEXP0_OUT					0x00000001
#define MC07_SEL_GEXP1_OUT					0x00000002
#define MC07_SEL_GEXP2_OUT					0x00000004
#define MC07_SEL_GEXP3_OUT					0x00000008
#define MC07_SEL_GEXP0_GEXP1_OUT			0x00000003
#define MC07_SEL_GEXP2_GEXP3_OUT			0x0000000c

#define MC07_SEL_GEXU0_OUT					0x00000100
#define MC07_SEL_GEXU1_OUT					0x00000200
#define MC07_SEL_GEXU2_OUT					0x00000400
#define MC07_SEL_GEXU3_OUT					0x00000800

#define MC07_SEL_GP_IN						0x00010000
#define MC07_SEL_EXP0_IN					0x00040000
#define MC07_SEL_EXP1_IN					0x00080000
#define MC07_SEL_CTLP0_IN					0x00020000
#define MC07_SEL_GP0_IN						0x00100000
#define MC07_SEL_GP1_IN						0x00200000
#define MC07_SEL_EXP0_EXP1_IN				0x000c0000
#define MC07_SEL_GP0_GP1_IN					0x00300000

#define MC07_SEL_GEXP0_IN					0x00010000
#define MC07_SEL_GEXP1_IN					0x00020000
#define MC07_SEL_GEXP2_IN					0x00040000
#define MC07_SEL_GEXP3_IN					0x00080000
#define MC07_SEL_GEXP0_GEXP1_IN				0x00030000
#define MC07_SEL_GEXP2_GEXP3_IN				0x000c0000

#define MC07_SEL_GEXU0_IN					0x01000000
#define MC07_SEL_GEXU1_IN					0x02000000
#define MC07_SEL_GEXU2_IN					0x04000000
#define MC07_SEL_GEXU3_IN					0x08000000

/******************************************************************************

	STRUCTURE

******************************************************************************/
/*============================================================================
	MC07_S_RESULT
============================================================================*/
typedef struct MC07_TAG_S_RESULT {
	WORD			MC07_Result[4];
} MC07_S_RESULT;

/*============================================================================
	MC07_S_DATA
============================================================================*/
typedef struct _MC07_S_DATA {
	WORD			MC07_Data[4];
} MC07_S_DATA;

/*============================================================================
	MC07_S_COMMAND_DATA
============================================================================*/
typedef struct _MC07_S_COMMAND_DATA {
	WORD			Command;
	DWORD			Data;
} MC07_S_COMMAND_DATA;

/*============================================================================
	MC07_S_STATUS_DATA
============================================================================*/
typedef struct _MC07_S_STATUS_DATA {
	WORD			Status1;
	DWORD			Data;
} MC07_S_STATUS_DATA;

/*============================================================================
	MC07_S_SLAVE_INFO
============================================================================*/
typedef struct _MC07_S_SLAVE_INFO{
	WORD			SlaveType[15];
	WORD			GExuType[60];
}MC07_S_SLAVE_INFO;

/*============================================================================
	MC07_S_IN_PORT
============================================================================*/
typedef struct _MC07_S_IN_PORT {
	WORD			Gpin;
	WORD			Gp0in;
	WORD			Gp1in;
	WORD			Exp0in;
	WORD			Exp1in;
	WORD			Ctlp0in;
	WORD			GExu0in[4];
	WORD			GExu1in[4];
	WORD			GExu2in[4];
	WORD			GExu3in[4];
	WORD			GExu0out[4];
	WORD			GExu1out[4];
	WORD			GExu2out[4];
	WORD			GExu3out[4];
	WORD			GExpin[4];
	WORD			GExpout[4];
} MC07_S_IN_PORT;

/*============================================================================
	MC07_S_OUT_PORT
============================================================================*/
typedef struct _MC07_S_OUT_PORT {
	WORD			Gpout;
	WORD			Gp0out;
	WORD			Gp1out;
	WORD			Exp0out;
	WORD			Exp1out;
	WORD			Ctlp0out;
	WORD			GExu0out[4];
	WORD			GExu1out[4];
	WORD			GExu2out[4];
	WORD			GExu3out[4];
	WORD			GExpout[4];
} MC07_S_OUT_PORT;

/*============================================================================
	MC07_S_UNIT_STATUS
============================================================================*/
typedef struct _MC07_S_UNIT_STATUS {
	MC07_S_STATUS_DATA		X;
	MC07_S_STATUS_DATA		Y;
	MC07_S_STATUS_DATA		Z;
	MC07_S_STATUS_DATA		A;
	MC07_S_IN_PORT			InPort;
} MC07_S_UNIT_STATUS;

/*============================================================================
	MC07_S_UNIT_COMMAND
============================================================================*/
typedef struct _MC07_S_UNIT_COMMAND {
	MC07_S_COMMAND_DATA		X;
	MC07_S_COMMAND_DATA		Y;
	MC07_S_COMMAND_DATA		Z;
	MC07_S_COMMAND_DATA		A;
	MC07_S_OUT_PORT			OutPort;
} MC07_S_UNIT_COMMAND;

/*============================================================================
	MC07_S_AXIS_MCM_STATUS
============================================================================*/
typedef struct _MC07_S_AXIS_MCM_STATUS {
	WORD	Status;
	WORD	NopData;
	DWORD	Data;
} MC07_S_AXIS_MCM_STATUS;

/*============================================================================
	MC07_S_UNIT_MCM_STATUS
============================================================================*/
typedef struct _MC07_S_UNIT_MCM_STATUS {
	WORD					McmStatus1;
	WORD					McmStatus2;
	MC07_S_AXIS_MCM_STATUS	X;
	MC07_S_AXIS_MCM_STATUS	Y;
	MC07_S_AXIS_MCM_STATUS	Z;
	MC07_S_AXIS_MCM_STATUS	A;
	WORD					Gpin;
	WORD					Ctlp0in;
	WORD					Exp0in;
	WORD					Exp1in;
} MC07_S_UNIT_MCM_STATUS;

/*============================================================================
	MC07_S_AXIS_MCM_ERROR_STATUS
============================================================================*/
typedef struct _MC07_S_AXIS_MCM_ERROR_STATUS {
	WORD	ErrorCode;
	WORD	MccErrorStatus;
	WORD	MccErrorStatusMask;
	WORD	OriginErrorStatus;
} MC07_S_AXIS_MCM_ERROR_STATUS;

/*============================================================================
	MC07_S_UNIT_MCM_ERROR_STATUS
============================================================================*/
typedef struct _MC07_S_UNIT_MCM_ERROR_STATUS {
	MC07_S_AXIS_MCM_ERROR_STATUS X;
	MC07_S_AXIS_MCM_ERROR_STATUS Y;
	MC07_S_AXIS_MCM_ERROR_STATUS Z;
	MC07_S_AXIS_MCM_ERROR_STATUS A;
} MC07_S_UNIT_MCM_ERROR_STATUS;

/*============================================================================
	MC07_S_AXIS_MCM_SPEC
============================================================================*/
typedef struct _MC07_S_AXIS_MCM_SPEC {
	WORD	Spec;
} MC07_S_AXIS_MCM_SPEC;

/*============================================================================
	MC07_S_UNIT_MCM_SPEC
============================================================================*/
typedef struct _MC07_S_UNIT_MCM_SPEC {
	MC07_S_AXIS_MCM_SPEC	X;
	MC07_S_AXIS_MCM_SPEC	Y;
	MC07_S_AXIS_MCM_SPEC	Z;
	MC07_S_AXIS_MCM_SPEC	A;
} MC07_S_UNIT_MCM_SPEC;

/*============================================================================
	MC07_S_AXIS_MCM_INFO
============================================================================*/
typedef struct _MC07_S_AXIS_MCM_INFO {
	DWORD	Address;
} MC07_S_AXIS_MCM_INFO;

/*============================================================================
	MC07_S_UNIT_MCM_INFO
============================================================================*/
typedef struct _MC07_S_UNIT_MCM_INFO {
	WORD					SheetNo;
	MC07_S_AXIS_MCM_INFO	X;
	MC07_S_AXIS_MCM_INFO	Y;
	MC07_S_AXIS_MCM_INFO	Z;
	MC07_S_AXIS_MCM_INFO	A;
} MC07_S_UNIT_MCM_INFO;

/*============================================================================
	MC07_S_AXIS_MCM_START_DATA
============================================================================*/
typedef struct _MC07_S_AXIS_MCM_START_DATA {
	DWORD	Address;
} MC07_S_AXIS_MCM_START_DATA;

/*============================================================================
	MC07_S_UNIT_MCM_START_DATA
============================================================================*/
typedef struct _MC07_S_UNIT_MCM_START_DATA {
	MC07_S_AXIS_MCM_START_DATA X;
	MC07_S_AXIS_MCM_START_DATA Y;
	MC07_S_AXIS_MCM_START_DATA Z;
	MC07_S_AXIS_MCM_START_DATA A;
} MC07_S_UNIT_MCM_START_DATA;

/*============================================================================
	MC07_S_COMMAND_BUF
============================================================================*/
typedef struct _MC07_S_COMMAND_BUF {
	WORD			Command[16];
} MC07_S_COMMAND_BUF;

/*============================================================================
	MC07_S_DATA_BUF
============================================================================*/
typedef struct _MC07_S_DATA_BUF {
	DWORD			Data[16];
} MC07_S_DATA_BUF;

/*============================================================================
	MC07_S_STATUS_BUF
============================================================================*/
typedef struct _MC07_S_STATUS_BUF {
	WORD			Status[16];
} MC07_S_STATUS_BUF;

/*============================================================================
	MC07_S_SPEED_RATE
============================================================================*/
typedef struct _MC07_S_SPEED_RATE {
	DWORD			FSpd;
	DWORD			HighSpeed;
	DWORD			LowSpeed;
	DWORD			EndLowSpeed;
	DWORD			SUArea;
	DWORD			SDArea;
	DWORD			SUH;
	DWORD			SDH;
	DWORD			URateNo;
	DWORD			DRateNo;
} MC07_S_SPEED_RATE;

/*============================================================================
	MC07_S_XY_POSITION
============================================================================*/
typedef struct _MC07_S_XY_POSITION {
	LONG			X;
	LONG			Y;
} MC07_S_XY_POSITION;

/*============================================================================
	MC07_S_ORG_PARAM
============================================================================*/
typedef struct _MC07_S_ORG_PARAM {
	DWORD			Spec;
	DWORD			MarginPulse;
	DWORD			LimitDelay;
	DWORD			ScanDelay;
	DWORD			PulseDelay;
	DWORD			CScanErrorPulse;
	DWORD			PulseErrorPulse;
	DWORD			OffsetPulse;
	LONG			PresetPulse;
} MC07_S_ORG_PARAM;

/******************************************************************************

	FUNCTION

******************************************************************************/

#if !defined(_AL2FUNC_)
	#define AL2_API __declspec( dllimport )
#else
	#define AL2_API __declspec( dllexport )
#endif

#ifdef __cplusplus
extern"C"{
#endif

AL2_API BOOL WINAPI MC07_Environment( WORD BoardNo, WORD CommRate, WORD RetryCount, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_ReadSlaveInfo( WORD BoardNo, MC07_S_SLAVE_INFO *psSlaveInfo, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_ErrCount( WORD BoardNo, WORD *pCount, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_ClrErrCount( WORD BoardNo, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UOpen( WORD UnitNo, DWORD *phUnit, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UClose( DWORD hUnit, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UClrError( DWORD hUnit, DWORD AxisSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UWExUnitCommMode( DWORD hUnit, WORD CommRate, WORD RetryCount, WORD IoBit, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UWExUnitCommControl( DWORD hUnit, WORD ControlSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_URExUnitCommStatus( DWORD hUnit, WORD *pStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_URExUnitCommMode( DWORD hUnit, WORD *pCommRate, WORD *pRetryCount, WORD *pIoBit, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UWGExUnitCommMode( DWORD hUnit, WORD CommRate, WORD RetryCount, WORD IoBit, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UWGExUnitCommControl( DWORD hUnit, WORD ControlSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_URGExUnitCommStatus( DWORD hUnit, WORD *pStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_URGExUnitCommMode( DWORD hUnit, WORD *pCommRate, WORD *pRetryCount, WORD *pIoBit, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UWDriveIo( DWORD hUnit, DWORD AxisSel, DWORD IoPortSel, MC07_S_UNIT_COMMAND *psUnitCmd, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UWRDrive( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_COMMAND *psUnitCmd, MC07_S_UNIT_STATUS *psUnitStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_URStatus1Io( DWORD hUnit, DWORD AxisSel, DWORD IoPortSel, MC07_S_UNIT_STATUS *psUnitStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_URStatus1PcntIo( DWORD hUnit, DWORD AxisSel, DWORD IoPortSel, MC07_S_UNIT_STATUS *psUnitStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UPortOut( DWORD hUnit, DWORD IoPortSel, MC07_S_OUT_PORT *psOutPort, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UPortOrOut( DWORD hUnit, DWORD IoPortSel, MC07_S_OUT_PORT *psOutPort, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UPortAndOut( DWORD hUnit, DWORD IoPortSel, MC07_S_OUT_PORT *psOutPort, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UPortIn( DWORD hUnit, DWORD IoPortSel, MC07_S_IN_PORT *psInPort, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UReadMcmStatus( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_STATUS *psUnitMcmStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UReadMcmErrorStatus( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_ERROR_STATUS *psUnitMcmErrorStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_USetMcmSpec0( DWORD hUnit, WORD Spec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UGetMcmSpec0( DWORD hUnit, WORD *pSpec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_USetMcmSpec1( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_SPEC *psUnitMcmSpec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UGetMcmSpec1( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_SPEC *psUnitMcmSpec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_USetMcmSpec2( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_SPEC *psUnitMcmSpec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UGetMcmSpec2( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_SPEC *psUnitMcmSpec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_USetMcmSpec3( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_SPEC *psUnitMcmSpec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UGetMcmSpec3( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_SPEC *psUnitMcmSpec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UReleaseMcmSheetLock( DWORD hUnit, WORD SheetNo, CHAR Password[], MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UDownloadMcmSheet( DWORD hUnit, WORD SheetNo, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UWriteMcmRam( DWORD hUnit, WORD Axis, DWORD Address, MC07_S_COMMAND_DATA *psCmdData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UReadMcmRam( DWORD hUnit, WORD Axis, DWORD Address, MC07_S_COMMAND_DATA *psCmdData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UReadMcmInfo( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_INFO *psUnitMcmInfo, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UWaitMcmReady( DWORD hUnit, DWORD AxisSel, WORD WaitTime, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UReadMcmWaitStatus( DWORD hUnit, DWORD AxisSel, WORD *pWaitSts, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UBreakMcmWait( DWORD hUnit, DWORD AxisSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UStartMcm( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_MCM_START_DATA *psUnitMcmStartData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UPauseMcm( DWORD hUnit, DWORD AxisSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_URestartMcm( DWORD hUnit, DWORD AxisSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UFsstopMcm( DWORD hUnit, DWORD AxisSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_USlstopMcm( DWORD hUnit, DWORD AxisSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_UClrMcmError( DWORD hUnit, DWORD AxisSel, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BOpen( WORD UnitNo, WORD Axis, DWORD *phDev, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BClose( DWORD hDev, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_ClrError( DWORD hDev, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BufWDrive( DWORD hDev, MC07_S_COMMAND_BUF *psCmdBuf, MC07_S_DATA_BUF *psDataBuf, WORD Count, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_LWDrive( DWORD hDev, WORD Cmd, DWORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_LWData( DWORD hDev, DWORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_IWDrive( DWORD hDev, WORD Cmd, MC07_S_DATA *psData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_IWData( DWORD hDev, MC07_S_DATA *psData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_LWDriveBuf( DWORD hDev, MC07_S_COMMAND_DATA CmdDataBuf[], WORD Count, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BWDriveCommand( DWORD hDev, WORD *pCmd, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BWDriveData1( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BWDriveData2( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_AllRStatus( DWORD hDev, MC07_S_STATUS_BUF *psStsBuf, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRStatus1( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRStatus2( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRStatus3( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRStatus4( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRStatus5( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRStatusBuf( DWORD hDev, WORD StatusBuf[], MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_LRDrive( DWORD hDev, DWORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_IRDrive( DWORD hDev, MC07_S_DATA *psData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRDriveData1( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRDriveData2( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_LWRDrive( DWORD hDev, WORD Cmd, DWORD *pWriteData, DWORD *pReadData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BWRDrive( DWORD hDev, WORD Cmd, DWORD *pReadData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRNopData( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BWaitDriveCommand( DWORD hDev, WORD WaitTime, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BWaitComregNotFull( DWORD hDev, WORD WaitTime, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BIsWait( DWORD hDev, WORD *pWaitSts, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BBreakWait( DWORD hDev, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_SetSpeedRate( DWORD hDev, WORD ResolNo, MC07_S_SPEED_RATE *psSpeedRate, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_ReadSpeedRate( DWORD hDev, WORD *pResolNo, MC07_S_SPEED_RATE *psSpeedRate, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_McIncStrCp( DWORD hDevX, DWORD hDevY, WORD DrvSpec, MC07_S_XY_POSITION *psTargetPosition, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_McIncCirCp( DWORD hDevX, DWORD hDevY, WORD DrvSpec, WORD Dir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_XY_POSITION *psTargetPosition, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_IncStrCp( DWORD hDevX, DWORD hDevY, WORD DrvSpec, MC07_S_XY_POSITION *psTargetPosition, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_IncCirCp( DWORD hDevX, DWORD hDevY, WORD DrvSpec, WORD Dir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_XY_POSITION *psTargetPosition, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_GetCirShortPulse( WORD Dir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_XY_POSITION *psTargetPosition, LONG *pShortPulse, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_GetCirCenterPosition( MC07_S_XY_POSITION *psPassPosition, MC07_S_XY_POSITION *psTargetPosition, WORD *pDir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_IncFromAbs( DWORD hDevX, DWORD hDevY, MC07_S_XY_POSITION *psAbsPosition, MC07_S_XY_POSITION *psIncPosition, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_ReadOrgStatus( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_SetOrgSpec( DWORD hDev, WORD Spec, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_SetOrgMarginPulse( DWORD hDev, DWORD MarginPulse, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_SetOrgDelay( DWORD hDev, WORD LimitDelay, WORD ScanDelay, WORD PulseDelay, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_SetOrgErrorPulse( DWORD hDev, DWORD CscanErrorPulse, DWORD PulseErrorPulse, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_SetOrgOffsetPulse( DWORD hDev, DWORD OffsetPulse, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_SetOrgPresetPulse( DWORD hDev, LONG PresetPulse, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_ReadOrgParam( DWORD hDev, MC07_S_ORG_PARAM *psOrgParam, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_ResetOrgFlag( DWORD hDev, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_Org( DWORD hDev, WORD OrgType, MC07_S_RESULT *psResult );
AL2_API VOID WINAPI MC07_SetData( DWORD Data, MC07_S_DATA *psData );
AL2_API DWORD WINAPI MC07_GetData( MC07_S_DATA *psData );
AL2_API BOOL WINAPI MC07_BPortOpen( WORD UnitNo, WORD IoPort, DWORD *phPort, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BPortClose( DWORD hPort, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BPortOut( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BPortOrOut( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BPortAndOut( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BPortIn( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BSigActiveOut( DWORD hPort, WORD SigNo, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BSigNotActiveOut( DWORD hPort, WORD SigNo, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BSigIn( DWORD hPort, WORD SigNo, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BWLatchEdge( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRLatchEdge( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BWLatchClr( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
AL2_API BOOL WINAPI MC07_BRLatchData( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
AL2_API WORD WINAPI MC07_Unsigned16( SHORT Data );
AL2_API SHORT WINAPI MC07_Signed16( WORD Data );
AL2_API DWORD WINAPI MC07_Unsigned32( LONG Data );
AL2_API LONG WINAPI MC07_Signed32( DWORD Data );

#ifdef __cplusplus
}
#endif
